package com.alicloud.openservices.tablestore.model;

import com.alicloud.openservices.tablestore.core.utils.Preconditions;

import java.util.List;
import java.util.Map;

public class SQLQueryResponse extends Response {
    /**
     * 此次操作消耗的能力单元。
     */
    private Map<String, ConsumedCapacity> consumedCapacityByTable;
    /**
     * 范围查询返回的所有行。
     */
    private List<Row> rows;

    /**
     * internal use
     */
    public SQLQueryResponse(Response meta, Map<String, ConsumedCapacity> consumedCapacityByTable) {
        super(meta);
        Preconditions.checkNotNull(consumedCapacityByTable);
        this.consumedCapacityByTable = consumedCapacityByTable;
    }

    /**
     * internal use
     */
    public void setRows(List<Row> rows) {
        this.rows = rows;
    }

    /**
     * 获取此次操作消耗的CapacityUnit。
     *
     * @return 此次操作消耗的CapacityUnit。
     */
    public Map<String, ConsumedCapacity> getConsumedCapacity() {
        return consumedCapacityByTable;
    }

    /**
     * 获取本次查询返回的所有行。
     *
     * @return 所有行
     */
    public List<Row> getRows() {
        return rows;
    }
}
