package com.alicloud.openservices.tablestore.model.timeseries;

import com.alicloud.openservices.tablestore.model.OperationNames;
import com.alicloud.openservices.tablestore.model.Request;

public class GetTimeseriesDataRequest implements Request {

    private final String timeseriesTableName;
    private TimeseriesKey timeseriesKey;
    private long beginTimeInUs;
    private long endTimeInUs;
    private int limit = -1;
    private byte[] nextToken;

    public GetTimeseriesDataRequest(String timeseriesTableName) {
        this.timeseriesTableName = timeseriesTableName;
    }

    public String getTimeseriesTableName() {
        return timeseriesTableName;
    }

    public TimeseriesKey getTimeseriesKey() {
        return timeseriesKey;
    }

    public void setTimeseriesKey(TimeseriesKey timeseriesKey) {
        this.timeseriesKey = timeseriesKey;
    }

    public void setTimeRange(long beginTimeInUs, long endTimeInUs) {
        this.beginTimeInUs = beginTimeInUs;
        this.endTimeInUs = endTimeInUs;
    }

    public long getBeginTimeInUs() {
        return beginTimeInUs;
    }

    public long getEndTimeInUs() {
        return endTimeInUs;
    }

    public void setNextToken(byte[] nextToken) {
        this.nextToken = nextToken;
    }

    public byte[] getNextToken() {
        return nextToken;
    }

    @Override
    public String getOperationName() {
        return OperationNames.OP_GET_TIMESERIES_DATA;
    }

    public int getLimit() {
        return limit;
    }

    public void setLimit(int limit) {
        this.limit = limit;
    }
}
